# OpenAPI Petstore
#
# This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
#
# The version of the OpenAPI document: 1.0.0
# 
# Generated by: https://openapi-generator.tech

#' @docType class
#' @title Fake operations
#' @description petstore.Fake
#' @format An \code{R6Class} generator object
#' @field apiClient Handles the client-server communication.
#'
#' @section Methods:
#' \describe{
#' \strong{ FakeDataFile } \emph{ test data_file to ensure it&#39;s escaped correctly }
#' 
#'
#' \itemize{
#' \item \emph{ @param } dummy character
#' \item \emph{ @param } var_data_file character
#' \item \emph{ @returnType } \link{User} \cr
#'
#'
#' \item status code : 200 | successful operation
#'
#' \item return type : User 
#' \item response headers :
#'
#' \tabular{ll}{
#' }
#' }
#'
#' }
#'
#'
#' @examples
#' \dontrun{
#' ####################  FakeDataFile  ####################
#'
#' library(petstore)
#' var.dummy <- 'dummy_example' # character | dummy required parameter
#' var.var_data_file <- 'var_data_file_example' # character | header data file
#'
#' #test data_file to ensure it's escaped correctly
#' api.instance <- FakeApi$new()
#'
#' result <- api.instance$FakeDataFile(var.dummy, var_data_file=var.var_data_file)
#'
#'
#' }
#' @importFrom R6 R6Class
#' @importFrom base64enc base64encode
#' @export
FakeApi <- R6::R6Class(
  'FakeApi',
  public = list(
    apiClient = NULL,
    initialize = function(apiClient){
      if (!missing(apiClient)) {
        self$apiClient <- apiClient
      }
      else {
        self$apiClient <- ApiClient$new()
      }
    },
    FakeDataFile = function(dummy, var_data_file=NULL, data_file=NULL, ...){
      apiResponse <- self$FakeDataFileWithHttpInfo(dummy, var_data_file, data_file=data_file, ...)
      resp <- apiResponse$response
      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        apiResponse$content
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        apiResponse
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        apiResponse
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        apiResponse
      }
    },

    FakeDataFileWithHttpInfo = function(dummy, var_data_file=NULL, data_file=NULL, ...){
      args <- list(...)
      queryParams <- list()
      headerParams <- c()

      if (missing(`dummy`)) {
        stop("Missing required parameter `dummy`.")
      }

      headerParams['dummy'] <- `dummy`

      headerParams['data_file'] <- `var_data_file`

      body <- NULL
      urlPath <- "/fake/data_file"

      resp <- self$apiClient$CallApi(url = paste0(self$apiClient$basePath, urlPath),
                                 method = "GET",
                                 queryParams = queryParams,
                                 headerParams = headerParams,
                                 body = body,
                                 ...)

      if (httr::status_code(resp) >= 200 && httr::status_code(resp) <= 299) {
        # save response in a file
        if (!is.null(data_file)) {
            write(httr::content(resp, "text", encoding = "UTF-8", simplifyVector = FALSE), data_file)
        }

        deserializedRespObj <- tryCatch(
          self$apiClient$deserialize(resp, "User", loadNamespace("petstore")),
          error = function(e){
             stop("Failed to deserialize response")
          }
        )
        ApiResponse$new(deserializedRespObj, resp)
      } else if (httr::status_code(resp) >= 300 && httr::status_code(resp) <= 399) {
        ApiResponse$new(paste("Server returned " , httr::status_code(resp) , " response status code."), resp)
      } else if (httr::status_code(resp) >= 400 && httr::status_code(resp) <= 499) {
        ApiResponse$new("API client error", resp)
      } else if (httr::status_code(resp) >= 500 && httr::status_code(resp) <= 599) {
        ApiResponse$new("API server error", resp)
      }
    }
  )
)
